using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_Contabilidad._0_Modelos;
using Exferia_Contabilidad.General;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Contabilidad._3_Vistas.Listados
{
    public class ABS_Listado_CTA_AmortizacionesLinea : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_CTA_AmortizacionesLinea()
        {
            Rellenar_columnas();
        }

        private void Rellenar_columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, false, false, "", null, false));
           
            //linea
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.linea), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.linea), "Linea", G_ENUM_TIPOSDATOS.INT, false, 150, true, true, true, false, "", null, false));

            //Inmovilizado
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_INMOVILIZADO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.idInmovilizado), nameof(CTA_Inmovilizados), nameof(CTA_Inmovilizados.id), nameof(CTA_Inmovilizados.numeroOrden), nameof(CTA_Inmovilizados.concepto), nameof(CTA_Inmovilizados.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.Inmovilizado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.Inmovilizado), "Inmovilizado", G_ENUM_TIPOSDATOS.RELACIONADA, false, 300, true, true, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_INMOVILIZADO));

            //Inmovilizado_ImporteAmortizable
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.Inmovilizado_ImporteAmortizable), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.Inmovilizado_ImporteAmortizable), "Importe amortizable", G_ENUM_TIPOSDATOS.DECIMAL, false, 120, true, false, false, false, "", null, false));

            //tipoAmortizacion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.tipoAmortizacion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.tipoAmortizacion), "Tipo amortización", G_ENUM_TIPOSDATOS.DECIMAL, false, 100, true, false, false, false, "", null, false));

            //fechaCalculoInicio
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.fechaCalculoInicio), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.fechaCalculoInicio), "F. Inicio calculo", G_ENUM_TIPOSDATOS.DATETIME, false, 120, true, false, false, false, "", null, false));

            //fechaCalculoFin
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.fechaCalculoFin), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.fechaCalculoFin), "F. Fin Calculo", G_ENUM_TIPOSDATOS.DATETIME, false, 120, true, false, false, false, "", null, false));

            //importeAmortizar
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.importeAmortizar), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.importeAmortizar), "Importe amortizar", G_ENUM_TIPOSDATOS.DECIMAL, false, 100, true, false, false, false, "", null, false));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CTA_AMORTIZACIONESLINEA);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_CTA_AMORTIZACIONESLINEA;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_CTA_AmortizacionesLinea_Listado_Modelo.linea);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
